'Option Strict Off
'Option Explicit On 
'Imports System
Imports System.Runtime.InteropServices
Imports System.Text


Module Declare_APIs

#If IS_64_BIT = True Then
    Private Const FLEng_Dll As String = "flengine.dll"
#Else
    Private Const FLEng_Dll As String = "fleng32.dll"

#End If

#If ANSI = True Then
    Const cSet As CharSet = CharSet.Ansi
    Const eSpell As Boolean = True
#Else
    Const cSet As CharSet = CharSet.Unicode
    Const eSpell As Boolean = False
#End If


    Public Delegate Function LinkDialogCallBack(ByVal BufferPtr As Integer) As Integer
    Public Delegate Sub EventCallBackEx(ByVal ChannelNo As Integer, ByVal EventNumber As Integer, ByVal EventData As Integer)
    Public Delegate Sub EventCallBack(ByVal ChannelNo As Integer, ByVal EventNumber As Integer)
    Public Delegate Sub CoordsCallBack(ByVal hwnd As Integer, ByVal lParam As Integer)

#Region "Helper Functions"
    Function SendFLCommandWithHelp(ByVal ThisChannel As Integer, ByVal Index As fl_cmd, Optional ByVal ThirdParam As Integer = 0) As Integer
        'just a wrapper around SendFLCommand which gives you selectable indexes, rather than having to look up the numbers
        Return SendFLCommand(ThisChannel, Index, ThirdParam)
    End Function

    Function GetFLStatusWithHelp(ByVal ThisChannel As Integer, ByVal Index As fl_status) As Integer
        'just a wrapper around GetFLStatus which gives you selectable indexes, rather than having to look up the numbers
        Return GetFLStatus(ThisChannel, Index)
    End Function

    Function GetFLConfigWithHelp(ByVal ThisChannel As Integer, ByVal Index As fl_cfg, ByRef FlagNo As Integer, ByRef StrVal As String) As Integer
        'just a wrapper around SetFLConfig which gives you selectable indexes, rather than having to look up the numbers
        Dim retVal As Integer
        Dim Answer As New StringBuilder(256)
        retVal = GetFLConfig(ThisChannel, Index, FlagNo, Answer)
        StrVal = Answer.ToString
        Return retVal
    End Function

    Function SetFLConfigWithHelp(ByVal ThisChannel As Integer, ByVal Index As fl_cfg, ByVal FlagNo As Integer, ByVal StrVal As String) As Integer
        'just a wrapper around SetFLConfig which gives you selectable indexes, rather than having to look up the numbers
        Return SetFLConfig(ThisChannel, Index, FlagNo, StrVal)
    End Function

    Public Enum fl_cfg
        AUTO_REDRAW = 1
        'BACKGROUND_COLOR = 2
        PROMPT_FOR_MISSING_FILES = 3
        MEASURE_MULTIPLIER = 4
        USE_XREFS = 5
        DISP_WIDE_PLINES = 6
        ACAD_VIEW_MODE = 7
        CIRCL_SMOOTHNESS = 8
        MULITASK_RATE = 9
        USE_ACAD_16_COLOR = 10
        DISP_ALL_CAD_ATTR = 11
        USE_REDLINE_DIRECTORY = 12
        USE_LINK_DIRECTORY = 13
        USE_RED_OPTS_DIRECTORY = 14
        USE_LAYER_CFG_DIRECTORY = 15
        USE_DGN_FONT_LIBRARY = 16
        MEASURE_MULTIPLIER_DGN = 18
        MEASURE_UNITS = 19
        MEASURE_UNITS_DGN = 20
        AUTO_MAXIMIZE = 21
        INITIAL_ZOOM_STATE = 22
        PRINT_MULTITASK_RATE = 23
        DEFAULT_DGN_VIEW = 24
        USE_PCP_FILE = 25
        USE_ACAD_ASI_INI_FILE = 26
        USE_RED_SYMBOL_FILE = 27
        USE_LINK_SYMBOL_FILE = 28
        RASTER_CONTRAST = 29
        USE_GLOBAL_REDLINE_DEF_FILE = 30
        MONOCROME_VECTOR = 31
        USE_OVERLOOK_BUTTONS = 32
        PICK_BOX_SIZE = 33
        STORE_CLIP_IN_MEMORY = 34
        DEFAULT_PEN_WIDTH = 35
        EDIT_FLPCP = 36
        ScrollBars = 37
        SUPPRESS_WINDOW_BORDER = 38
        USE_GAS_GAUGE = 39
        ALLOW_ZOOMS = 40
        HAND_CURSOR_OVER_LINKS = 41
        DISPLAY_VIEWMARKS = 42
        VIEWMARK_COLOR = 43
        USE_PREVIOUS_LINK_ZOOM_STATE = 44
        LAYER_CONFIG_NAME = 45
        EXPORT_V2RDPI = 46
        EXPORT_PCP_FILE = 47
        EXPORT_V2RBM_HEIGHT = 48
        EXPORT_V2R_PENWIDTH = 49
        USE_DYNAMIC_PAN = 50
        'USE_3D_DISPLAY_MODE = 51
        USE_CAD_FONTS = 52
        USE_LAYOUT_TABS = 53
        MAX_ENTITY_SEGMENTS = 54
        MAX_HATCH_POINTS = 55
        MAX_SPLINE_POINTS = 56
        DEFAULT_FONT = 57
        BACKGROUND_COLOR = 64
    End Enum

    Public Enum fl_status
        REDLINE_ON = 1
        LINKING_ON = 2
        SCROLL_BARS_ON = 3
        AUTO_REDRAW_ON = 4
        BACKGROUND_COLOR = 5
        PROMPT_FOR_MISSING_FILES = 6
        INITIAL_ZOOM_STATE = 7
        FASTZOOMS_ON = 8
        USE_FONTS = 9
        USE_LINETYPES = 10
        USE_XREFS = 11
        WIDE_PLINES = 12
        ACAD_VIEW_MODE = 13
        CIRCLE_SMOOTHNESS = 14
        IS_ACAD = 16
        SUPPORTS_BWCOPY = 17
        SUPPORTS_ZOOM_SCALE = 18
        SUPPORTS_ZOOM_LIMITS = 19
        SUPPORTS_BLOCKS = 20
        SUPPORTS_LAYERS = 21
        SUPPORTS_VIEWS = 22
        SUPPORTS_VIEWPOINT = 23
        SUPPORTS_TIME_INFO = 24
        SUPPORTS_ASSOC_FILES = 25
        SUPPORTS_VECTOR_PRINT = 26
        CAN_ZOOM_PREVIOUS = 27
        CAN_RETRACE_LINK = 28
        DISPLAY_RED_ATTRIBUTES = 29
        AUTO_RED_ATT_EDIT_MODE = 30
        DISPLAY_RED_FILLS = 31
        RED_HIGHLIGHT_FILL_MODE = 32
        RED_SOLID_FILL_MODE = 33
        IN_MEASURE_MODE = 34
        GAS_GAUGE_ON = 35
        SUPPORTS_BLOCK_DATA = 36
        SUPPORTS_EXTENDED_DATA = 37
        SUPPORTS_DATABASE_LINKS = 38
        SUPPORTS_ENTITY_ID = 39
        SHOW_HIDDEN_LINKS = 40
        AUTO_FILL_ON = 41
        STILL_DRAWING = 42
        RED_FILE_EXISTS = 43
        LINK_FILE_EXISTS = 44
        OVERLOOK_EXISTS = 45
        IS_COMPARE_WINDOW = 46
        IMAGE_TYPE = 47
        MONOCHROME_VECTOR = 48
        CAN_ZOOM_IN = 49
        CAN_ZOOM_OUT = 50
        CAN_ZOOM_EXTENT = 51
        CAN_PAN = 52
        CONTRAST_LEVEL = 53
        TEXT_STAMP_ON = 54
        IS_OUTSIDEIN_FILE = 55
        CAN_COPY_TO_CLIP = 56
        CAN_DO_CLIP_CONFIG = 57
        CURRENT_PAGE_NUMBER = 58
        CAN_EXIT = 60
        DGN_MEASURE_UNITS = 61
        MEASURE_UNITS = 62
        GRAYSCALE_MODE = 78
        ORTHO_MODE = 79
        IN_PAPERSPACE = 80
        SUPPORTS_PAPERSPACE = 81
        AUTO_ZOOMS_ON = 84
        DOTS_PER_INCH = 85
        TOTAL_NUM_PAGES = 86
        SHOW_HAND_OVER_LINKS = 87
        SUPPORTS_OBJECT_DATA = 88
        SELECTION_MODE = 89
        DRAWING_MODE = 90
        RED_DISPLAY_VIEWMARKS = 91
        RED_VIEWMARK_COLOR = 92
        NUM_LAYOUTS = 93
        UNDO_ACTION = 94
        RESTORE_PREVIOUS_LINK_ZOOMSTATE = 95
        USER_RIGHTCLICK_MENU_ITEM = 96
        SUPPORTS_SHEETS = 97
        FILE_TYPE = 98
        IN_3D_ROTATE_MODE = 99
        USE_LAYOUT_TABS = 101
        MOUSE_MODE = 104
        AUTO_MAXIMIZE_ON = 105
        DYNAMIC_PAN_ON = 106

    End Enum

    Public Enum fl_cmd
        FILE_OPEN_FILE_DIALOG_WINDOWS = 199
        FILE_OPEN_FILE_DIALOG = 3
        FILE_SAVE_AS = 4
        FILE_PRINT = 7
        FILE_PRINT_SETUP = 24
        FILE_EXPORT = 68
        FILE_SEARCH = 126
        FILE_OVERLOOK_ON = 490
        FILE_OVERLOOK_OFF = 491
        FILE_TEXT_FIND_DLG = 725

        COPY_BITMAP = 70
        COPY_VECTOR = 71
        COPY_SELECTED_TO_CLIPBOARD = 425
        COPY_CLIPBOARD_CONFIG = 426

        DISP_REDRAW_NOW = 103
        DISP_ZOOM_EXTENTS = 10
        DISP_ZOOM_SCALE = 11
        DISP_ZOOM_IN = 12
        DISP_ZOOM_OUT = 13
        DISP_LAYER_CFG = 143
        DISP_LAYERS = 14
        DISP_BLOCKS = 15
        DISP_ZOOM_PREVIOUS = 65
        DISP_ZOOM_LIMITS = 66
        DISP_ACAD_VIEWS = 67
        DISP_MONOCHROME_MODE_ON = 175
        DISP_MONOCHROME_MODE_OFF = 176
        DISP_ROTATE_CLOCKWISE = 382
        DISP_ROTATE_COUNTERCLOCKWISE = 384
        DISP_ROTATE_TO_90 = 385
        DISP_ROTATE_TO_180 = 386
        DISP_ROTATE_TO_270 = 387
        DISP_ROTATE_TO_0 = 388
        DISP_INVERT_BW = 410
        DISP_CONTRAST_LIGHTEST = 419
        DISP_CONTRAST_LIGHT = 420
        DISP_CONTRAST_DARK = 421
        DISP_CONTRAST_DARKEST = 422
        DISP_PAPERSPACE_ON = 435
        DISP_PAPERSPACE_OFF = 436
        DISP_LAYOUTS = 437
        DISP_GRAYSCALE_ON = 461
        DISP_GRAYSCALE_OFF = 462
        DISP_GOTO_PAGE = 492
        DISP_PREV_PAGE = 493
        DISP_NEXT_PAGE = 494
        DISP_FIRST_PAGE = 495
        DISP_LAST_PAGE = 496
        DISP_ZOOM_IN_50_ATCURSOR = 497
        DISP_VIEW_POINT = 21
        DISP_PAN = 23
        DISP_ROTATE_3D = 798


        RED_DRAW_LEADER = 73
        RED_MOVE_ENTITY = 75
        RED_DELETE_ENTITY = 76
        RED_REDLINE_ON = 92
        RED_DRAW_LINE = 94
        RED_DRAW_BOX = 95
        RED_DRAW_CIRCLE = 96
        RED_EDIT_NOTE = 97
        RED_DRAW_SKETCH = 98
        RED_DRAW_NOTE = 99
        RED_DELETE_FILE = 100
        RED_PREFERENCES = 102
        RED_DRAW_ARC_CSE = 118
        RED_DRAW_PLINE = 119
        RED_DRAW_CLOUD = 120
        RED_ATTRIBUTES_ON = 138
        RED_SEND_TAG_ON_CLICK = 142
        RED_MAKE_ATTR_TAGS = 145
        RED_CAD_IMPORT = 147
        RED_HATCH_MODE = 148
        RED_DELETE_ALL_HATCH = 149
        RED_HATCH_PATTERN_DLG = 150
        RED_SET_HATCH_TYPE = 152
        RED_SET_HATCH_WIDTH = 153
        RED_SEND_PLINE_AREA = 156
        RED_REDLINE_OFF = 161
        RED_DISPLAY_FILLS_ON = 203
        RED_DISPLAY_FILLS_OFF = 204
        RED_SOLID_FILL_MODE_ON = 205
        RED_SOLID_FILL_MODE_OFF = 206
        RED_HIGHLIGHT_FILL_MODE_ON = 207
        RED_HIGHLIGHT_FILL_MODE_OFF = 208
        RED_DRAW_STICKY_NOTE = 209
        RED_FILL_CLOSED_ENTITY = 210
        RED_CREATE_SYMBOL = 211
        RED_INSERT_SYMBOL = 212
        RED_DRAW_ARC_3POINT = 213
        RED_DRAW_ARC_SER = 214
        RED_SELECTION_MODE_ON = 215
        RED_SELECTION_MODE_OFF = 216
        RED_COPY_ENTITY = 226
        RED_ATTRIBUTES_OFF = 227
        RED_CHANGE_LAYER = 228
        RED_EDIT_ENTITY_W_TAG = 391
        RED_AUTO_FILL_ON = 392
        RED_AUTO_FILL_OFF = 393
        RED_EDIT_NOTE_W_ATTR = 395
        RED_PREFERENCES_W_ATTR = 397
        RED_REDLINE_OPTIONS = 398
        RED_CAPTURE_DWG_ENTITIES = 400
        RED_ORTHO_MODE_ON = 463
        RED_ORTHO_MODE_OFF = 464
        RED_DISPLAY_VIEWMARKS = 510
        RED_ADD_VIEWMARK = 511

        LINK_LINKING_OFF = 162
        LINK_SHOW_HIDDEN_ON = 164
        LINK_SHOW_HIDDEN_OFF = 165
        LINK_GOTO_FIRST_LINK = 167
        LINK_DRAW_PLINE = 168
        LINK_GOTO_PREVIOUS_LINK = 104
        LINK_DRAW_BOX = 105
        LINK_DELETE_ENTITY = 106
        LINK_MOVE_ENTITY = 107
        LINK_RESIZE_ENTITY = 108
        LINK_EDIT_LINK_ATTR = 109
        LINK_LINKING_ON = 110
        LINK_DELETE_FILE = 111
        LINK_HISTORY = 135
        LINK_SELECTION_MODE_ON = 217
        LINK_SELECTION_MODE_OFF = 218
        LINK_DRAW_CIRCLE = 405
        LINK_DRAW_CLOUD = 406
        LINK_INSERT_SYMBOL = 407
        LINK_COPY_ENTITY = 409

        INFO_GET_ATTRIBUTES = 171
        INFO_GET_DBASE_LINKS = 172
        INFO_GET_EXTENDED_DATA = 173
        INFO_IDENTIFY_ENTITY = 174
        INFO_GET_OBJECT_DATA = 177
        INFO_TIME = 51
        INFO_DWG_INFO = 52
        INFO_CALIBRATE_MEASURE = 411
        INFO_MEASURE_DISTANCE = 79
        INFO_MEASURE_MULTI_DISTANCE = 80
        INFO_ASSOCIATED_FILES = 116
        INFO_MEASURE_POLYGON_AREA = 390

        OPT_LAYOUT_TABS_ON = 717
        OPT_LAYOUT_TABS_OFF = 718
        OPT_LINETYPE_ON = 719
        OPT_LINETYPE_OFF = 720
        OPT_CADFONT_ON = 721
        OPT_CADFONT_OFF = 722
        OPT_SET_HPGL_PEN_COLORS = 381
        OPT_GAS_GAUGE_ON = 200
        OPT_GAS_GAUGE_OFF = 201
        OPT_SCROLLBARS_OFF = 169
        OPT_SYSTEM_COLOR_OFF = 170
        OPT_CONFIGURE = 124
        OPT_SCROLLBARS_ON = 125
        OPT_SAVE_OPTIONS = 60
        OPT_SYSTEM_COLOR_ON = 62

        HELP_ABOUT_DIALOG = 9
    End Enum
#End Region


#Region "FastLook API"

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Function AddRedlineReference(ByVal Channel As Integer, ByVal FileName As String, ByVal CreateFlag As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function BringToTop(ByVal Channel As Integer, ByVal Handle As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function BringLinkToFront(ByVal Channel As Integer, ByVal LinkHandle As Integer, ByVal RedrawNow As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function BypassContextMenu(ByVal Channel As Integer, ByVal MenuIndex As Integer, ByVal YesNo As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function CenterAndZoom(ByVal Channel As Integer, ByVal X1 As Double, ByVal Y1 As Double, ByVal Height As Double) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function CloseDataChannel(ByVal Channel As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function CloseDwgWindow(ByVal Channel As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function CloseEmbeddedOverLookWindow() As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function CloseOverLookWindow() As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function CompareFiles(ByVal CompareChannel As Integer, ByVal Channel1 As Integer, ByVal Channel2 As Integer, ByVal Color1 As Integer, ByVal Color2 As Integer, ByVal UseDialog As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function CreateLinkEntity(ByVal Channel As Integer, ByVal Handle As Integer, ByVal LinkType As Integer, ByVal StoreString As String, ByVal EntityType As Integer, ByVal NumPoints As Integer, ByRef PointsArray As Double, ByVal Radius As Double, ByVal Rotation As Double, ByVal SymbolName As String, ByVal SymbolScale As Double, ByVal RedrawFlag As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function CreateLinkEntityStr(ByVal Channel As Integer, ByVal Handle As Integer, ByVal LinkType As Integer, ByVal StoreString As String, ByVal EntityType As Integer, ByVal NumPoints As Integer, ByVal PointsStr As String, ByVal RadiusStr As String, ByVal RotationStr As String, ByVal SymbolName As String, ByVal SymbolScaleStr As String, ByVal RedrawFlag As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function CreateRedLayer(ByVal Channel As Integer, ByVal LayerName As String, ByVal VisibleFlag As Integer, ByVal Color As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function CreateRedEntity(ByVal Channel As Integer, ByVal Handle As String, ByVal EntityType As Integer, ByVal NumPoints As Integer, ByRef PointsArray As Double, ByVal Radius As Double, ByVal Rotation As Double, ByVal SymbolName As String, ByVal SymbolScale As Double, ByVal NoteText As String, ByVal RedrawFlag As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function CreateRedEntityStr(ByVal Channel As Integer, ByVal Handle As String, ByVal EntityType As Integer, ByVal NumPoints As Integer, ByVal PointsStr As String, ByVal RadiusStr As String, ByVal RotationStr As String, ByVal SymbolName As String, ByVal SymbolScaleStr As String, ByVal NoteText As String, ByVal RedrawFlag As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function CreateRedSymbolFromSelectedEntities(ByVal Channel As Integer, ByVal SymbolName As String, ByVal SymbolFile As String, ByVal DeleteSelectedEntities As Integer, ByVal OkToOverwriteSymbol As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function DeleteLinkEntity(ByVal Channel As Integer, ByVal Handle As Integer, ByVal EraseFlag As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function DeleteLinkSymbolFromFile(ByVal Channel As Integer, ByVal SymbolName As String) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function DeleteRedEntity(ByVal Channel As Integer, ByVal Handle As String, ByVal EraseFlag As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function DeleteRedFills(ByVal Channel As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function DeleteRedLayer(ByVal Channel As Integer, ByVal LayerName As String) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function DeleteRedSymbolFromFile(ByVal Channel As Integer, ByVal SymbolName As String) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function DoDragDropLinkSymbol(ByVal Channel As Integer, ByVal LinkType As Integer, ByVal SymbolName As String, ByVal SymbolScale As Double, ByVal ColorIndexOrRGB As String, ByVal Rotation As Double, ByVal DataString As String, ByVal OverwritePriority As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function DoDragDropRedSymbol(ByVal Channel As Integer, ByVal Tag As String, ByVal SymbolName As String, ByVal SymbolScale As Double, ByVal ColorIndexOrRGB As String, ByVal Rotation As Double, ByVal OverwritePriority As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function DoesTagExist(ByVal Channel As Integer, ByVal Tag As String) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function DrawDwgFile(ByVal Channel As Integer, ByVal FileName As String) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function DrawDwgFileView(ByVal Channel As Integer, ByVal dwgName As String, ByVal XCenter As Double, ByVal YCenter As Double, ByVal Height As Double, ByVal ViewpointX As Double, ByVal ViewpointY As Double, ByVal ViewpointZ As Double) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function DrawThisTempFile(ByVal Channel As Integer, ByVal FileName As String) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function DuplicateSelectedLinks(ByVal Channel As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function DuplicateSelectedRedlineEntities(ByVal Channel As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function DwgWindowSize(ByVal Channel As Integer, ByVal X1 As Integer, ByVal Y1 As Integer, ByVal w As Integer, ByVal h As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function EmbeddedOverLookChangeChannel(ByVal Channel As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function EmbeddedOverlookSetReticleStyle(ByVal Style As Integer, ByVal FillColor As String, ByVal BorderColor As String) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function EmbeddedOverLookWindowSize(ByVal Xpos As Integer, ByVal Ypos As Integer, ByVal wWidth As Integer, ByVal sHeight As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function EmbeddedOverLookZoomPrevious() As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function EmbeddedOverLookZoomToReticle() As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function EndMeasure(ByVal Channel As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function ExportFile(ByVal Channel As Integer, ByVal Drawing As String, ByVal ToDrawing As String) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Function ExportLinkFile(ByVal Channel As Integer, ByVal BaseDrawing As String, ByVal ToFile As String) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function FindAllLinksThatContainLinks(ByVal Channel As Integer, ByVal ByvalReturnString As StringBuilder, ByRef ReturnStringSize As Integer, ByVal Flag As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function FindAllLinksWithinThisLink(ByVal Channel As Integer, ByVal LinkID As Integer, ByVal ReturnString As StringBuilder, ByRef ReturnStringSize As Integer, ByVal Flag As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function FindEntityAtCoords(ByVal Channel As Integer, ByVal X As Double, ByVal Y As Double) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function FindFirstLink(ByVal Channel As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function FindFirstTag(ByVal Channel As Integer, ByVal Tag As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function FindFirstTagTypeAndName(ByVal Channel As Integer, ByVal Tag As StringBuilder, ByVal EntityType As StringBuilder, ByVal EntityName As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function FindNextLink(ByVal Channel As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function FindNextTag(ByVal Channel As Integer, ByVal Tag As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function FindNextTagTypeAndName(ByVal Channel As Integer, ByVal Tag As StringBuilder, ByVal EntityType As StringBuilder, ByVal EntityName As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function FindPlineAreaByTag(ByVal Channel As Integer, ByVal Tag As String) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function FlashRedEntByTag(ByVal Channel As Integer, ByVal Tag As String, ByVal Fcolor As Integer, ByVal Bcolor As Integer, ByVal Duration As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function FLDrawBlock(ByVal Channel As Integer, ByVal BlockName As String) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function FLEngineVersion(ByVal FullVersion As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function FLFreeResources() As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function FLLogin(ByVal UserName As StringBuilder, ByVal Password As StringBuilder, ByVal UseDialog As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function FLSetCursor(ByVal Channel As Integer, ByVal CursorIndex As Integer, ByVal CursorFile As String) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function FLSetDialogControlColors(ByVal Type As Integer, ByVal SubType As Integer, ByVal Red As Integer, ByVal Green As Integer, ByVal Blue As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetClickCoordStr(ByVal Channel As Integer, ByVal Button As Integer, ByVal Units As Integer, ByVal Xposition As StringBuilder, ByVal Yposition As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetColorInfo(ByVal ColorNum As Integer, ByVal RGBVal As StringBuilder, ByVal ColorName As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetColorPaletteIndex(ByVal hwndParent As Integer, ByVal x As Integer, ByVal y As Integer, ByRef ColorNum As Integer, ByVal RGBstr As StringBuilder, ByVal ColorName As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetCurrentLayoutName(ByVal Channel As Integer, ByVal LayoutName As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetDrawingExtents(ByVal Channel As Integer, ByRef X1 As Double, ByRef Y1 As Double, ByRef X2 As Double, ByRef Y2 As Double) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetDrawingExtentsStr(ByVal Channel As Integer, ByVal X1 As StringBuilder, ByVal Y1 As StringBuilder, ByVal X2 As StringBuilder, ByVal Y2 As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetDrawingWindowRectStr(ByVal Channel As Integer, ByVal Left As StringBuilder, ByVal Top As StringBuilder, ByVal Right As StringBuilder, ByVal Bottom As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetDroppedFile(ByVal Channel As Integer, ByVal FileName As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetDwgCreateDate(ByVal Channel As Integer, ByVal CreateDate As StringBuilder, ByVal CreateTime As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetDwgEditTime(ByVal Channel As Integer, ByVal EditTime As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetDwgElapsedTimer(ByVal Channel As Integer, ByVal ElapsedTime As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetDwgName(ByVal Channel As Integer, ByVal FileName As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetDwgThumbNail(ByVal DrawingFileName As String, ByVal BitmapFileName As String) As IntPtr
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetDwgUpdateDate(ByVal Channel As Integer, ByVal UpdateDate As StringBuilder, ByVal UpdateTime As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetEntityDataByTag(ByVal Channel As Integer, ByVal Tag As String, ByVal Value As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetEntityInfoByTag(ByVal Channel As Integer, ByVal Tag As String, ByVal Value As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetFastLookINIEntry(ByVal Tag As String, ByVal Value As StringBuilder, ByVal DefaultStr As String, ByVal Section As String, ByVal Path As String, ByVal GetFromINI As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetFirstBlockInsert(ByVal Channel As Integer, ByVal BlockName As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetFirstBlockName(ByVal Channel As Integer, ByVal BlockName As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetFirstDroppedFile(ByVal Channel As Integer, ByVal FileName As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetFirstEntity(ByVal Channel As Integer, ByVal EntityType As String, ByVal LayoutList As String) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetFirstEntityData(ByVal Channel As Integer, ByVal Tag As StringBuilder, ByVal Value As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetFirstEntityInfo(ByVal Channel As Integer, ByVal Tag As StringBuilder, ByVal Value As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)>
    Public Function GetFirstEntityInRect(ByVal Channel As Integer, ByVal EntityType As String, ByVal X1 As Double, ByVal Y1 As Double, ByVal X2 As Double, ByVal Y2 As Double, ByVal Mode As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetFirstLayerConfigName(ByVal Channel As Integer, ByVal LayerConfigName As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetFirstLayerName(ByVal Channel As Integer, ByVal LayerName As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetFirstLayoutName(ByVal Channel As Integer, ByVal LayoutName As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetFirstLinkSymbolName(ByVal Channel As Integer, ByVal SymbolName As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetFirstObjectDataField(ByVal Channel As Integer, ByVal TableName As StringBuilder, ByRef NumFields As Integer, ByVal FieldName As StringBuilder, ByVal FieldDescription As StringBuilder, ByVal Value As StringBuilder, ByVal FieldType As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetFirstObjectDataTableField(ByVal Channel As Integer, ByVal TableName As StringBuilder, ByRef NumFields As Integer, ByVal FieldName As StringBuilder, ByVal FieldDescription As StringBuilder, ByVal DefaultValue As StringBuilder, ByVal FieldType As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetFirstRasterReference(ByVal Channel As Integer, ByVal FileName As String, ByVal RasterFileName As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetFirstRedFontStyleName(ByVal Channel As Integer, ByVal FontStyleName As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetFirstRedLayerName(ByVal Channel As Integer, ByVal LayerName As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetFirstRedlineReference(ByVal Channel As Integer, ByVal RedlineFileName As String, ByVal ReferenceFileName As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetFirstRedLineStyleName(ByVal Channel As Integer, ByVal LineStyleName As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetFirstRedSymbolName(ByVal Channel As Integer, ByVal SymbolName As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetFirstSelEntity(ByVal Channel As Integer, ByVal Tag As StringBuilder, ByVal Reserved As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetFirstTextEntity(ByVal Channel As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetFirstViewName(ByVal Channel As Integer, ByVal ViewName As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetFirstXrefBlock(ByVal Channel As Integer, ByVal FileName As String, ByVal BlockName As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetFLConfig(ByVal Channel As Integer, ByVal Index As Integer, ByRef Flag As Integer, ByVal StringVal As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Sub GetFLSn(ByVal SerialNum As StringBuilder)
    End Sub

    <DllImport(FLEng_Dll)> _
    Public Function GetFLStatus(ByVal Channel As Integer, ByVal Tag As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetLayerAttributes(ByVal Channel As Integer, ByVal LayerName As String, ByVal Attrib As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetLinkData(ByVal Channel As Integer, ByVal LinkHandle As Integer, ByVal DataType As Integer, ByVal DataString As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetLinkHandle(ByVal Channel As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetLinkString(ByVal Channel As Integer, ByVal LinkString As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetLinkSymbolBitmap(ByVal Channel As Integer, ByVal SymbolName As String, ByVal Width As Integer, ByVal Height As Integer, ByVal BackColorIndexOrRGB As String, ByVal ForeColorIndexOrRGB As String, ByRef hBitmap As IntPtr) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetLinkSymbolSize(ByVal Channel As Integer, ByVal SymbolName As String, ByVal SymbolFile As String, ByRef Width As Double, ByRef Height As Double) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetLinkSymbolSizeStr(ByVal Channel As Integer, ByVal SymbolName As String, ByVal SymbolFile As String, ByVal SizeStr As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetMasterRedlineFileName(ByVal Channel As Integer, ByVal OriginalFileName As String, ByVal MasterFileName As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetMeasure(ByVal Channel As Integer, ByVal Measurement As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetMultiplier(ByVal Channel As Integer, ByVal Tag As Integer, ByVal Mutiplier As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetNamedViewInfoByTag(ByVal Channel As Integer, ByVal ViewName As String, ByVal Tag As String, ByVal Value As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetNextBlockInsert(ByVal Channel As Integer, ByVal BlockName As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetNextBlockName(ByVal Channel As Integer, ByVal BlockName As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetNextDroppedFile(ByVal Channel As Integer, ByVal FileName As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetNextEntity(ByVal Channel As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)>
    Public Function GetNextEntityInRect(ByVal Channel As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetNextEntityData(ByVal Channel As Integer, ByVal Tag As StringBuilder, ByVal Value As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetNextEntityInfo(ByVal Channel As Integer, ByVal Tag As String, ByVal Value As String) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetNextLayerConfigName(ByVal Channel As Integer, ByVal LayerConfigName As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetNextLayerName(ByVal Channel As Integer, ByVal LayerName As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetNextLayoutName(ByVal Channel As Integer, ByVal LayoutName As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetNextLinkSymbolName(ByVal Channel As Integer, ByVal SymbolName As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetNextObjectDataField(ByVal Channel As Integer, ByVal TableName As StringBuilder, ByRef NumFields As Integer, ByVal FieldName As StringBuilder, ByVal FieldDescription As StringBuilder, ByVal Value As StringBuilder, ByVal FieldType As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetNextObjectDataTableField(ByVal Channel As Integer, ByVal TableName As StringBuilder, ByRef NumFields As Integer, ByVal FieldName As StringBuilder, ByVal FieldDescription As StringBuilder, ByVal DefaultValue As StringBuilder, ByVal FieldType As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetNextRasterReference(ByVal Channel As Integer, ByVal RasterFileName As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetNextRedFontStyleName(ByVal Channel As Integer, ByVal FontStyleName As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetNextRedLayerName(ByVal Channel As Integer, ByVal LayerName As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetNextRedlineReference(ByVal Channel As Integer, ByVal ReferenceFileName As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetNextRedLineStyleName(ByVal Channel As Integer, ByVal LineStyleName As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetNextRedSymbolName(ByVal Channel As Integer, ByVal SymbolName As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetNextSelEntity(ByVal Channel As Integer, ByVal Tag As StringBuilder, ByVal Reserved As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetNextTextEntity(ByVal Channel As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetNextViewName(ByVal Channel As Integer, ByVal ViewName As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetNextXrefBlock(ByVal Channel As Integer, ByVal BlockName As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetNumberOfPages(ByVal Channel As Integer, ByVal FileName As String) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetNumSelectedEntities(ByVal Channel As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetPolygonAreaByHandle(ByVal Channel As Integer, ByVal Handle As String) As Double
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetPrinterProperty(ByVal OptionIndex As Integer, ByVal Value As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetRectCoords(ByVal Channel As Integer, ByRef X1 As Double, ByRef Y1 As Double, ByRef X2 As Double, ByRef Y2 As Double) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetRectCoordsStr(ByVal Channel As Integer, ByVal X1 As StringBuilder, ByVal Y1 As StringBuilder, ByVal X2 As StringBuilder, ByVal Y2 As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetRedEntityProperties(ByVal Channel As Integer, ByVal Handle As String, ByVal PropIndex As Integer, ByVal PropertyString As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetRedLayerSettings(ByVal Channel As Integer, ByVal LayerName As String, ByVal PropIndex As Integer, ByVal ValueString As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetRedlineAttribute(ByVal Channel As Integer, ByVal AttributeStr As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetRedlineFileStatus(ByVal Channel As Integer, ByVal FileName As String, ByVal Index As Integer, ByVal Reserved As String) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetRedlineGroupProperties(ByVal Channel As Integer, ByVal GroupName As String, ByVal PropIndex As Integer, ByVal PropertyString As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetRedlinePath(ByVal Channel As Integer, ByVal RedlinePath As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetRedSymbolSize(ByVal Channel As Integer, ByVal SymbolName As String, ByVal SymbolFile As String, ByRef Width As Double, ByRef Height As Double) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetRedSymbolBitmap(ByVal Channel As Integer, ByVal SymbolName As String, ByVal Width As Integer, ByVal Height As Integer, ByVal BackColorRGB As String, ByVal ForeColorRGB As String, ByRef hBitmap As IntPtr) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetUser(ByVal UserName As StringBuilder, ByVal Password As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetViewPoint(ByVal Channel As Integer, ByVal Xpos As StringBuilder, ByVal Ypos As StringBuilder, ByVal Zpos As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetWindowCoords(ByVal Channel As Integer, ByRef X1 As Double, ByRef Y1 As Double, ByRef X2 As Double, ByRef Y2 As Double) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function GetWindowCoordsStr(ByVal Channel As Integer, ByVal X1 As StringBuilder, ByVal Y1 As StringBuilder, ByVal X2 As StringBuilder, ByVal Y2 As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function HatchRedEntByTag(ByVal Channel As Integer, ByVal Tag As String) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function HatchTextPlineByTag(ByVal Channel As Integer, ByVal FileName As String, ByVal Delimeter As String) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function HideAllLinks(ByVal Channel As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function HighlightPolygon(ByVal Channel As Integer, ByVal EntityHandle As String, ByVal Color As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function IdentifyFileType(ByVal FileName As String) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function ImageToPixelCoordsStr(ByVal Channel As Integer, ByVal X As StringBuilder, ByVal Y As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function ImportCadToRed(ByVal Channel As Integer, ByVal CadLayer As String, ByVal RedLayer As String, ByVal DelRedBeforeAddFlag As Integer, ByVal CreateNewRedLayerFlag As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function InsertLinkSymbol(ByVal Channel As Integer, ByVal LinkType As Integer, ByVal SymbolName As String, ByVal SymbolScale As Double, ByVal ColorIndexOrRGB As String, ByVal Rotation As Double, ByVal DataString As String, ByVal OverwritePriority As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function InsertRedSymbol(ByVal Channel As Integer, ByVal Tag As String, ByVal SymbolName As String, ByVal SymbolScale As Double, ByVal ColorIndexOrRGB As String, ByVal Rotation As Double, ByVal OverwritePriority As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function IsAcadDwg(ByVal Channel As Integer, ByVal FileName As String) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function KillRedlineFlash(ByVal Channel As Integer) As Integer
    End Function

    '*** obsolete in V14
    'Declare Function LaunchAcad (ByVal Channel As Integer, ByVal FileName As String) As Integer

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function LinkHistoryGetFirst(ByVal Channel As Integer, ByVal FileName As StringBuilder, ByVal strlen As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function LinkHistoryGetNext(ByVal Channel As Integer, ByVal FileName As StringBuilder, ByVal strlen As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function LinkReloadFile(ByVal Channel As Integer, ByVal RedrawNow As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function LinkSaveNow(ByVal Channel As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function LoadBlockAttributes(ByVal Channel As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function LoadBlockInsertAttributes(ByVal Channel As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function LoadBlockInsertData(ByVal Channel As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function LoadBlockInsertInfo(ByVal Channel As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function LoadDatabaseLinkData(ByVal Channel As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function LoadExtendedData(ByVal Channel As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function LoadFileForData(ByVal Channel As Integer, ByVal FileName As String) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function LoadObjectData(ByVal Channel As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function LoadObjectDataTables(ByVal Channel As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function LoadPolygons(ByVal Channel As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function LoadTextEntities(ByVal Channel As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function MakeLink(ByVal Channel As Integer, ByVal StoreString As String, ByVal Capt As String, ByVal TextHeight As Double, ByVal Color As Integer, ByVal HideFlag As Integer, ByVal PlineFlag As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function MakeRedAttributeTags(ByVal Channel As Short, ByVal RedLayer As String, ByVal TextToAddToNote As String, ByVal AddTextBeforeNoteFlag As Integer, ByVal AddSpaceFlag As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function MouseClickAction(ByVal Channel As Integer, ByVal MouseButtonNum As Integer, ByVal TypeAction As Integer, ByVal SubAction As Integer, ByVal ThirdParam As Integer, ByVal MenuString As String) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function MoveSelectedLinks(ByVal Channel As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function MoveSelectedRedlineEntities(ByVal Channel As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)>
    Public Function OpenDataChannel(ByVal Channel As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function OpenDwgWindow(ByVal hParent As IntPtr, ByVal Channel As Integer, ByVal Xpos As Integer, ByVal Ypos As Integer, ByVal wWidth As Integer, ByVal sHeight As Integer) As IntPtr
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function OpenDwgWindowName(ByVal ParentName As String, ByVal Channel As Integer, ByVal Xpos As Integer, ByVal Ypos As Integer, ByVal wWidth As Integer, ByVal sHeight As Integer) As IntPtr
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function OpenEmbeddedOverLookWindow(ByVal hParent As IntPtr, ByVal Channel As Integer, ByVal Xpos As Integer, ByVal Ypos As Integer, ByVal wWidth As Integer, ByVal sHeight As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function OpenFileDialog(ByVal Channel As Integer, ByVal FileMask As StringBuilder, ByVal FileTypes As StringBuilder, ByVal Overwrite As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)>
    Public Function OpenOverLookWindow(ByVal hParent As IntPtr, ByVal Channel As Integer, ByVal Xpos As Integer, ByVal Ypos As Integer, ByVal wWidth As Integer, ByVal sHeight As Integer, ByVal WinTitle As String) As IntPtr
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function OverLookChangeChannel(ByVal Channel As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function PixelToImageCoordsStr(ByVal Channel As Integer, ByVal X As StringBuilder, ByVal Y As StringBuilder) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function PostDrawWndCommand(ByVal Channel As Integer, ByVal WinMessage As Integer, ByVal wParam As IntPtr, ByVal lParam As IntPtr) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function PlaceDwgNote(ByVal Channel As Integer, ByVal NoteStr As String, ByVal X1 As Double, ByVal Y1 As Double, ByVal Color As Integer, ByVal Height As Double, ByVal Length As String) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function PlaceRectangle(ByVal Channel As Integer, ByVal X1 As Double, ByVal Y1 As Double, ByVal X2 As Double, ByVal Y2 As Double, ByVal Color As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function PrintFile(ByVal Channel As Integer, ByVal FileMask As String, ByVal Dialog As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function PrintFileOptions(ByVal Channel As Integer, ByVal FileMask As String, ByVal Mode As Integer, ByVal Selection As Integer, ByVal PScale As Double, ByVal AScale As Double, ByVal xoff As Double, ByVal yoff As Double, ByVal Copies As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function PrintFileToFile(ByVal Channel As Integer, ByVal FileMask As String, ByVal OutFileMask As String, ByVal Mode As Integer, ByVal Selection As Integer, ByVal PScale As Double, ByVal AScale As Double, ByVal xoff As Double, ByVal yoff As Double, ByVal Copies As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function RedEntFillByTag(ByVal Channel As Integer, ByVal TagName As String, ByVal FillType As Integer, ByVal Color As Integer, ByVal PaintNow As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function RedlineReloadFile(ByVal Channel As Integer, ByVal RedrawNow As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function RedlineSaveNow(ByVal Channel As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function RedSymbolPlaceAtDWGCoords(ByVal Channel As Integer, ByVal SymbolFile As String, ByVal SymbolName As String, ByVal Xcoord As Double, ByVal Ycoord As Double, ByVal ScaleFactor As Double) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function RemoveRedlineReference(ByVal Channel As Integer, ByVal FileName As String, ByVal DeleteFlag As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function RenameLinkSymbolInFile(ByVal Channel As Integer, ByVal NewSymbolName As String, ByVal OldSymbolName As String) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function RenameRedSymbolInFile(ByVal Channel As Integer, ByVal NewSymbolName As String, ByVal OldSymbolName As String) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function SaveCurrentLayerConfig(ByVal Channel As Integer, ByVal ConfigName As String) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function SaveRedlineReferencesToFile(ByVal Channel As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Function SearchDialog(ByVal Channel As Integer, ByVal FileName As StringBuilder, ByVal FileNameMask As StringBuilder, ByVal OverWriteFlag As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function SelectLinkEntityByHandle(ByVal Channel As Integer, ByVal LinkHandle As Integer, ByVal SelectDeselect As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function SelectRedlineEntitiesByTag(ByVal Channel As Integer, ByVal szTags As String, ByVal SelectFlag As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function SendDrawWndCommand(ByVal Channel As Integer, ByVal WinMessage As Integer, ByVal wParam As IntPtr, ByVal lParam As IntPtr) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function SendFLCommand(ByVal Channel As Integer, ByVal Param1 As Integer, ByVal Param2 As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function SendLinkToBack(ByVal Channel As Integer, ByVal LinkHandle As Integer, ByVal RedrawNow As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function SetActiveLayout(ByVal Channel As Integer, ByVal LayoutName As String, ByVal ApplyToCurrentFile As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function SetClickSettings(ByVal Channel As Integer, ByVal Index As Integer, ByVal dX As Integer, ByVal dY As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function SetCoordsCallBack(ByVal Channel As Integer, ByVal Address As CoordsCallBack) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function SetCurrentWorkingDir(ByVal Channel As Integer, ByVal WorkingPath As String) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function SetEventCallBack(ByVal Channel As Integer, ByVal Address As EventCallBack) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function SetEventCallBackEx(ByVal Channel As Integer, ByVal Address As EventCallBackEx) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function SetFindLinkHandleMode(ByVal Channel As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function SetFlashColor(ByVal Channel As Integer, ByVal ForeGround As Integer, ByVal Background As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function SetFLConfig(ByVal Channel As Integer, ByVal IndexNo As Integer, ByVal FlagNo As Integer, ByVal StrVal As String) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function SetFLPrinter(ByVal PrinterName As String) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function SetLayerAttributes(ByVal Channel As Integer, ByVal LayerName As String, ByVal Visible As Integer, ByVal ColorIndex As Integer) As Integer
    End Function

    '*** obsolete after V12 - use SetActiveLayout *********
    'Declare Function SetLayout (ByVal Channel As Integer, ByVal LayoutName As String, ByVal ApplyToCurrentFile As Integer) As Integer
    '******************************************************

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function SetLinkData(ByVal Channel As Integer, ByVal LinkHandle As Integer, ByVal DataType As Integer, ByVal DataString As String) As Integer
    End Function

    <DllImport(FLEng_Dll)> _
    Public Function SetLinkDialogCallback(ByVal Channel As Integer, ByVal Address As LinkDialogCallBack) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function SetPageNumber(ByVal Channel As Integer, ByVal PageNumber As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function SetPrinterProperty(ByVal OptionIndex As Integer, ByVal Value As String) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function SetPrintOptions(ByVal Channel As Integer, ByVal Mode As Integer, ByVal Selection As Integer, ByVal PScale As Double, ByVal AScale As Double, ByVal xoff As Double, ByVal yoff As Double, ByVal Copies As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function SetPrintStamp(ByVal Channel As Integer, ByVal TextString As String, ByVal Position As Integer, ByVal DateAndTimeVal As Integer, ByVal Background As Integer, ByVal Font As String, ByVal Size As Integer, ByVal Style As String, ByVal Last As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function SetRedEntityProperties(ByVal Channel As Integer, ByVal Handle As String, ByVal PropIndex As Integer, ByVal PropertyString As String, ByVal RedrawFlag As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function SetRedLayerSettings(ByVal Channel As Integer, ByVal LayerName As String, ByVal IndexFlag As Integer, ByVal ValueString As String) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function SetRedlineFileStatus(ByVal Channel As Integer, ByVal FileName As String, ByVal PropertyIndex As Integer, ByVal PropertyValue As Integer, ByVal Reserved As String) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function SetRedlinePath(ByVal Channel As Integer, ByVal FileName As String) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function SetViewPoint(ByVal Channel As Integer, ByVal X1 As Double, ByVal Y1 As Double, ByVal Z1 As Double) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function ShowAllLinks(ByVal Channel As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function StartLinkFlash(ByVal Channel As Integer, ByVal LinkHandle As Integer, ByVal Duration As Integer, ByVal ForeGround As Integer, ByVal Background As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function StartMeasure(ByVal Channel As Integer, ByVal Mode As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function StopDrawing(ByVal Channel As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function StopLinkFlash(ByVal Channel As Integer, ByVal LinkHandle As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function SyncLinkFlash(ByVal Channel As Integer, ByVal SyncLevel As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function TogglePrintText(ByVal Channel As Integer, ByVal Mode As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function UpdateRedlineAttributes(ByVal Channel As Integer, ByVal TagFile As String, ByVal Delimiter As String, ByVal EndOfLine As String) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function ViewLayout(ByVal Channel As Integer, ByVal LayoutName As String) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function ViewStoredView(ByVal Channel As Integer, ByVal ViewName As String) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function ZoomDuringSelection(ByVal Channel As Integer) As Integer
    End Function

    <DllImport(FLEng_Dll, ExactSpelling:=eSpell, CharSet:=cSet)> _
    Public Function ZoomToRect(ByVal Channel As Integer, ByVal X1 As Double, ByVal Y1 As Double, ByVal X2 As Double, ByVal Y2 As Double) As Integer
    End Function


#End Region


#Region "Windows API"
    <DllImport("kernel32.dll")> _
    Public Function FreeLibrary(ByVal LibHandle As IntPtr) As Integer
    End Function

    <DllImport("kernel32.dll", ExactSpelling:=False, CharSet:=cSet)> _
    Public Function LoadLibrary(ByVal FLLib As String) As IntPtr
    End Function

    <DllImport("kernel32.dll", ExactSpelling:=False, CharSet:=cSet)> _
    Public Function GetPrivateProfileInt(ByVal fieldsection As String, ByVal inifield As String, ByVal DefaultNo As Integer, ByVal FLUserIni As String) As Integer
    End Function

    <DllImport("kernel32.dll", ExactSpelling:=False, CharSet:=cSet)> _
    Public Function GetPrivateProfileString(ByVal fieldsection As String, ByVal inifield As String, ByVal DefaultStr As String, ByVal Answer As StringBuilder, ByVal Size As Integer, ByVal UserIni As String) As Integer
    End Function

    <DllImport("kernel32.dll", ExactSpelling:=False, CharSet:=cSet)> _
    Public Function GetWindowsDirectory(ByVal WinPath As StringBuilder, ByVal Size As Integer) As Integer
    End Function

    <DllImport("kernel32.dll", ExactSpelling:=False, CharSet:=cSet)> _
    Public Function WritePrivateProfileString(ByVal fieldsection As String, ByVal inifield As String, ByVal FLPath As String, ByVal FLUserIni As String) As Integer
    End Function


    <DllImport("user32.dll", ExactSpelling:=False, CharSet:=cSet)> _
    Public Function WinHelp(ByVal hWndMain As IntPtr, ByVal lpszHelp As String, ByVal uCommand As Integer, ByVal dwData As Integer) As Integer
    End Function

    <DllImport("kernel32.dll")> _
    Public Function SetParent(ByVal WindToChange As IntPtr, ByVal NewParent As IntPtr) As IntPtr
    End Function

    <DllImport("kernel32.dll")> _
    Public Function GetParent(ByVal ChildWind As IntPtr) As IntPtr
    End Function

    <DllImport("kernel32.dll")> _
    Public Function GetLastError() As Integer
    End Function

    <DllImport("gdi32.dll")> _
    Public Function DeleteObject(ByVal hObject As IntPtr) As Integer
    End Function

    <DllImport("kernel32.dll", ExactSpelling:=False, CharSet:=cSet)> _
    Public Function GetTempFileName(ByVal lpszPath As String, ByVal lpPrefixString As String, ByVal wUnique As Integer, ByVal lpTempFileName As StringBuilder) As Integer
    End Function

#End Region

End Module