Imports System.IO
Imports System.Text


Public Class Form1
    Private Declare Function LoadModel Lib "flioptest.dll" (ByVal FileName As String) As Integer
    Private FirstActivation As Boolean = True

    Public Sub New()

        ' This call is required by the Windows Form Designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.

    End Sub

    Private Sub pnlFastLook_SizeChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles pnlFastLook.SizeChanged
        If Channel > 0 Then
            Dim thisPanel As Panel = sender
            DwgWindowSize(Channel, 0, 0, thisPanel.Width, thisPanel.Height)
        End If
    End Sub


    'Private Sub ToolStripTextBox1_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs)
    '    Dim ThisTB As ToolStripTextBox = sender
    '    If e.KeyCode = Keys.Enter Then
    '        Dim thisFile As String
    '        thisFile = gVars.DrawingPath & Trim(ThisTB.Text)
    '        If Path.HasExtension(thisFile) = False Then
    '            thisFile = thisFile & ".dwg"
    '        End If
    '        Call ViewFile(thisFile)
    '        'DrawDwgFile(Channel, gVars.DrawingPath & ThisTB.Text & ".dwg")
    '    End If
    'End Sub

    Private Sub OpenToolStripButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOpen.Click
        Call OpenFileDialog()
    End Sub

    Private Sub PrintToolStripButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPrint.Click
        SendFLCommandWithHelp(Channel, fl_cmd.FILE_PRINT)

    End Sub

    Private Sub btnZoomIn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnZoomIn.Click
        SendFLCommandWithHelp(Channel, fl_cmd.DISP_ZOOM_IN)
    End Sub

    Private Sub btnZoomOut_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnZoomOut.Click
        SendFLCommandWithHelp(Channel, fl_cmd.DISP_ZOOM_OUT)
    End Sub

    Private Sub btnZoomExt_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnZoomExt.Click
        SendFLCommandWithHelp(Channel, fl_cmd.DISP_ZOOM_EXTENTS)
    End Sub

    Private Sub btnZoomPrev_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnZoomPrev.Click
        SendFLCommandWithHelp(Channel, fl_cmd.DISP_ZOOM_PREVIOUS)
    End Sub

    Private Sub btnPan_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPan.Click
        SendFLCommandWithHelp(Channel, fl_cmd.DISP_PAN)
    End Sub

    Private Sub Form1_Activated(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Activated
        If FirstActivation = False Then
            Exit Sub
        End If
        FirstActivation = False


        Dim thisScreen As Screen
        Dim ScreenRect As New Rectangle(0, 0, 0, 0)
        For Each thisScreen In Screen.AllScreens
            ScreenRect = Rectangle.Union(ScreenRect, New Rectangle(thisScreen.WorkingArea.X, thisScreen.WorkingArea.Y, thisScreen.WorkingArea.Width, thisScreen.WorkingArea.Height))
        Next
        ScreenWidth = ScreenRect.Width
        ScreenHeight = ScreenRect.Height
        If uVars.FormMaximized Then
            MainFrm.WindowState = FormWindowState.Maximized
        Else
            If uVars.FormX >= 0 AndAlso uVars.FormX < ScreenWidth - 100 Then
                MainFrm.Left = uVars.FormX
            Else
                MainFrm.Left = 0
            End If
            If uVars.FormY >= 0 And uVars.FormY < ScreenHeight - 100 Then
                MainFrm.Top = uVars.FormY
            Else
                MainFrm.Top = 0
            End If
            If uVars.FormW > 50 Then
                MainFrm.Width = uVars.FormW
            Else
                MainFrm.Width = 800
            End If
            If uVars.FormH > 50 Then
                MainFrm.Height = uVars.FormH
            Else
                MainFrm.Height = 600
            End If
        End If

    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Call SaveUserSettings()
        Try
            CloseDwgWindow(Channel)
        Catch
        End Try
        Try
            If FLEngineHndl <> 0 Then
                FLFreeResources()
                FreeLibrary(FLEngineHndl)
            End If
        Catch
        End Try
    End Sub


    Private Sub btnRedOn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRedOn.Click
        Dim thisButton As ToolStripButton = sender
        If thisButton.Checked Then
            SendFLCommandWithHelp(Channel, fl_cmd.RED_REDLINE_ON)
        Else
            SendFLCommandWithHelp(Channel, fl_cmd.RED_REDLINE_OFF)
        End If
        Call CheckMenusAndButtons()
    End Sub



    Private Sub btnLayouts_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLayouts.Click
        SendFLCommandWithHelp(Channel, fl_cmd.DISP_LAYOUTS)

    End Sub


    Private Sub mConfiguration_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ConfigurationToolStripMenuItem.Click
        Dim retVal As Integer = SendFLCommandWithHelp(Channel, fl_cmd.OPT_CONFIGURE, 0)
    End Sub

    Private Sub mExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitToolStripMenuItem.Click
        Me.Close()
    End Sub


    Private Sub OpenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OpenToolStripMenuItem.Click
        Call OpenFileDialog()
    End Sub

    Private Sub OpenFileDialog()
        Dim od As New OpenFileDialog
        If FirstTimeForOpenDialog Then
            od.InitialDirectory = gVars.DrawingPath
            FirstTimeForOpenDialog = False
        End If
        od.Filter = "AutoCAD Drawings (.DWG)|*.dwg|All Files (*.*)|*.*"
        If od.ShowDialog = Windows.Forms.DialogResult.OK Then
            DrawDwgFile(Channel, od.FileName)
        End If

    End Sub

    Private Sub LaunchFastLookToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LaunchFastLookToolStripMenuItem.Click
        Call LaunchFastLook()
    End Sub

    Private Sub btnLaunchFastLook_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLaunchFastLook.Click
        Call LaunchFastLook()
    End Sub

    Private Sub btnSelectLink_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSelectLink.Click
        Dim thisButton As ToolStripMenuItem = sender
        If thisButton.Checked Then
            SendFLCommandWithHelp(Channel, fl_cmd.LINK_SELECTION_MODE_ON)
        Else
            SendFLCommandWithHelp(Channel, fl_cmd.LINK_SELECTION_MODE_OFF)
        End If
        CheckMenusAndButtons()
    End Sub

    Private Sub btnLinkingBox_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLinkingBox.Click
        SendFLCommandWithHelp(Channel, fl_cmd.LINK_DRAW_BOX)
    End Sub

    Private Sub btnSymbolLink_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSymbolLink.Click
        SendFLCommandWithHelp(Channel, fl_cmd.LINK_INSERT_SYMBOL)
    End Sub

    Private Sub btnLinkingOn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLinkingOn.Click
        Dim thisButton As ToolStripButton = sender
        If thisButton.Checked Then
            SendFLCommandWithHelp(Channel, fl_cmd.LINK_LINKING_ON)
        Else
            SendFLCommandWithHelp(Channel, fl_cmd.LINK_LINKING_OFF)
        End If
        Call CheckMenusAndButtons()
    End Sub

    Private Sub btnPrevLink_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPrevLink.Click
        SendFLCommandWithHelp(Channel, fl_cmd.LINK_GOTO_PREVIOUS_LINK)
    End Sub


    Private Sub btnBlockAttribute_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBlockAttribute.Click
        Dim retVal As Integer
        retVal = SendFLCommand(Channel, 171, 0)
        ExtractMode = 2
    End Sub

    Private Sub btnListTextEntities_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnListTextEntities.Click
        Dim Answer As Stringbuilder
        Dim NoTextEntities, i, retVal As Integer
        Dim TextStr, OutputFile, OutputBuf As String

        NoTextEntities = LoadTextEntities(Channel)
        OutputBuf = ""

        If NoTextEntities > 0 Then
            retVal = GetFirstTextEntity(Channel)
            If retVal = 1 Then
                Answer = New Stringbuilder(256)
                retVal = GetEntityInfoByTag(Channel, "8", Answer) ' get layer name
                If retVal > 0 Then
                    OutputBuf = "Layer Name: " & Answer.ToString & vbCrLf
                    Answer = New StringBuilder(256)
                    retVal = GetEntityInfoByTag(Channel, "1", Answer) ' get textual info

                    If retVal > 0 Then
                        TextStr = Answer.ToString
                        OutputBuf = OutputBuf & "Text: " & TextStr & vbCrLf & vbCrLf
                    End If
                End If
            End If

            For i = 0 To NoTextEntities - 1
                retVal = GetNextTextEntity(Channel)
                If retVal = 1 Then
                    Answer = New StringBuilder(256)
                    retVal = GetEntityInfoByTag(Channel, "8", Answer) ' get layer name

                    If retVal > 0 Then
                        OutputBuf = OutputBuf & "Layer Name: " & Answer.ToString & vbCrLf
                        Answer = New StringBuilder(256)
                        retVal = GetEntityInfoByTag(Channel, "1", Answer) ' get textual info

                        If retVal > 0 Then
                            TextStr = Answer.ToString
                            OutputBuf = OutputBuf & "Text: " & TextStr & vbCrLf & vbCrLf
                        End If
                    End If
                End If

            Next i

            OutputBuf = OutputBuf & "The total number of Text entities is:  " & Str(NoTextEntities)

            OutputFile = Path.GetDirectoryName(Application.ExecutablePath) & "\TEXTLST.TXT"
            If Dir(OutputFile) = "" Then 'no file exists
            Else
                File.Delete(OutputFile)
            End If

            Dim fs As New FileStream(OutputFile, FileMode.Create)
            Dim sw As New StreamWriter(fs)
            sw.Write(OutputBuf)
            sw.Close()
            fs.Close()
           
            Process.Start("notepad.exe", OutputFile)

        Else
            MsgBox("There are no text entities in this file")
        End If

    End Sub

    Private Sub btnListBlockAttribute_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnListBlockAttribute.Click
        Dim BlockName As String
        Dim Answer, TagAnswer, ValueAnswer As StringBuilder
        Dim TagName, Value, Drawing, OutputFile, OutputBuf As String
        Dim NoBlocks, i As Integer
        Dim ExcludeAttrWithNoValue As Short
        Dim retBlock, retAttr, retLoad, retval As Integer

        Answer = New StringBuilder(256)
        retval = GetDwgName(Channel, Answer)
        Drawing = Answer.ToString
        OutputBuf = "The Current File Name is:  " & Drawing & vbCrLf & vbCrLf

        NoBlocks = LoadBlockInsertData(Channel)

        Answer.Length = 0
        retBlock = GetFirstBlockInsert(Channel, Answer)
        BlockName = Answer.ToString

        For i = 1 To NoBlocks
            If i = 1 Then
                OutputBuf = OutputBuf & "The First Block Name is:  " & BlockName & vbCrLf
            Else
                OutputBuf = OutputBuf & "The Next Block Name is:  " & BlockName & vbCrLf
            End If
            retLoad = LoadBlockInsertAttributes(Channel)
            If retLoad > 0 Then
                TagAnswer = New StringBuilder(256)
                ValueAnswer = New StringBuilder(256)
                retAttr = GetFirstEntityData(Channel, TagAnswer, ValueAnswer)
                If TagAnswer.ToString <> "" Then
                    OutputBuf = OutputBuf & "   Attribute List:" & vbCrLf
                End If
                While retAttr > 0
                    If retAttr > 0 Then

                        TagName = TagAnswer.ToString
                        Value = ValueAnswer.ToString

                        If Value = "" And ExcludeAttrWithNoValue = 1 Then
                        Else
                            OutputBuf = OutputBuf & "     " & TagName & " = " & Value & vbCrLf
                        End If
                    End If
                    TagAnswer.Length = 0
                    ValueAnswer.Length = 0
                    retAttr = GetNextEntityData(Channel, TagAnswer, ValueAnswer)
                End While
            End If
            Answer.Length = 0
            retBlock = GetNextBlockInsert(Channel, Answer)
            BlockName = Answer.ToString
        Next i
        OutputBuf = OutputBuf & "The total number of Blocks is:  " & Str(NoBlocks) & vbCrLf

        OutputFile = Path.GetDirectoryName(Application.ExecutablePath) & "\" & "BLOCKLST.TXT"
        If Dir(OutputFile) = "" Then 'no file exists
        Else
            File.Delete(OutputFile)
        End If
        Dim fs As New FileStream(OutputFile, FileMode.Create)
        Dim sw As New StreamWriter(fs)
        sw.Write(OutputBuf)
        sw.Close()
        fs.Close()

        Process.Start("notepad.exe", OutputFile)

    End Sub

    Private Sub mMakeLinkAPI_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mMakeLinkAPI.Click
        Dim frmMakeLink As New MakeLinkForm
        frmMakeLink.Tag = "MakeLink"
        frmMakeLink.ShowDialog()
    End Sub

    Private Sub mEditUserDefinedLink_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mEditUserDefinedLink.Click
        Dim retVal As Integer
        retVal = SetFindLinkHandleMode(Channel)
    End Sub

    Private Sub mDeleteLink_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Dim retVal As Integer
        retVal = SendFLCommand(Channel, 106, 0)
    End Sub

    Private Sub mLinkingOn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mLinkingOn.Click
        Dim LinkingIsOn, retVal As Integer

        LinkingIsOn = GetFLStatusWithHelp(Channel, fl_status.LINKING_ON)
        If LinkingIsOn = 1 Then
            retVal = SendFLCommandWithHelp(Channel, fl_cmd.LINK_LINKING_OFF, 0)
        Else
            retVal = SendFLCommandWithHelp(Channel, fl_cmd.LINK_LINKING_ON, 0)
        End If
        Call CheckMenusAndButtons()
    End Sub

    Private Sub mRedlineOn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mRedlineOn.Click
        Dim RedliningIsOn, retVal As Integer

        RedliningIsOn = GetFLStatusWithHelp(Channel, fl_status.REDLINE_ON)
        If RedliningIsOn = 1 Then
            retVal = SendFLCommandWithHelp(Channel, fl_cmd.RED_REDLINE_OFF, 0)
        Else
            retVal = SendFLCommandWithHelp(Channel, fl_cmd.RED_REDLINE_ON, 0)
        End If
        Call CheckMenusAndButtons()
    End Sub


    Private Sub btnSelectRedline_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSelectRedline.Click
        Dim thisButton As ToolStripMenuItem = sender
        If thisButton.Checked Then
            SendFLCommandWithHelp(Channel, fl_cmd.RED_SELECTION_MODE_ON)
        Else
            SendFLCommandWithHelp(Channel, fl_cmd.RED_SELECTION_MODE_OFF)
        End If
        Call CheckMenusAndButtons()
    End Sub

    Private Sub btnLine_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLine.Click
        SendFLCommandWithHelp(Channel, fl_cmd.RED_DRAW_LINE)
    End Sub

    Private Sub btnBox_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBox.Click
        SendFLCommandWithHelp(Channel, fl_cmd.RED_DRAW_BOX)
    End Sub

    Private Sub btnCircle_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCircle.Click
        SendFLCommandWithHelp(Channel, fl_cmd.RED_DRAW_CIRCLE)
    End Sub

    Private Sub btnNote_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNote.Click
        SendFLCommandWithHelp(Channel, fl_cmd.RED_DRAW_NOTE)
    End Sub

    Private Sub mAPIHelp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mAPIHelp.Click
        Dim HelpFile As String
        HelpFile = FLObj.FastLookDir & "flapi.chm"
        If Dir(HelpFile) <> "" Then
            Process.Start(HelpFile)
        Else
            MsgboxA("Could not find the API Help file: " & HelpFile)
        End If
    End Sub

    Private Sub btnRedPreferences_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRedPreferences.Click
        SendFLCommandWithHelp(Channel, fl_cmd.RED_PREFERENCES)
    End Sub
End Class
